diff -ruNp linux-2.6.34.5/arch/x86/SYSCALLS.x86_32 linux-2.6.34.5-cher1/arch/x86/SYSCALLS.x86_32
--- linux-2.6.34.5/arch/x86/SYSCALLS.x86_32	1970-01-01 03:00:00.000000000 +0300
+++ linux-2.6.34.5-cher1/arch/x86/SYSCALLS.x86_32	2010-08-26 14:45:12.238562018 +0400
@@ -0,0 +1,345 @@
+sys_exit
+stub32_fork
+sys_read
+sys_write
+compat_sys_open
+sys_close
+sys32_waitpid
+sys_creat
+sys_link
+sys_unlink
+stub32_execve
+sys_chdir
+compat_sys_time
+sys_mknod
+sys_chmod
+sys_lchown16
+quiet_ni_syscall
+sys_stat
+sys32_lseek
+sys_getpid
+compat_sys_mount
+sys_oldumount
+sys_setuid16
+sys_getuid16
+compat_sys_stime
+compat_sys_ptrace
+sys_alarm
+sys_fstat
+sys_pause
+compat_sys_utime                	CAP
+quiet_ni_syscall
+quiet_ni_syscall
+sys_access
+sys_nice	
+quiet_ni_syscall
+sys_sync
+sys32_kill
+sys_rename
+sys_mkdir
+sys_rmdir
+sys_dup
+sys_pipe
+compat_sys_times
+quiet_ni_syscall
+sys_brk
+sys_setgid16
+sys_getgid16
+sys_signal
+sys_geteuid16
+sys_getegid16
+sys_acct
+sys_umount
+quiet_ni_syscall
+compat_sys_ioctl
+compat_sys_fcntl64
+quiet_ni_syscall
+sys_setpgid
+quiet_ni_syscall
+sys32_olduname
+sys_umask
+sys_chroot
+compat_sys_ustat
+sys_dup2
+sys_getppid
+sys_getpgrp
+sys_setsid
+sys32_sigaction
+sys_sgetmask
+sys_ssetmask
+sys_setreuid16
+sys_setregid16
+sys32_sigsuspend
+compat_sys_sigpending
+sys_sethostname
+compat_sys_setrlimit
+compat_sys_old_getrlimit
+compat_sys_getrusage
+compat_sys_gettimeofday
+compat_sys_settimeofday
+sys_getgroups16
+sys_setgroups16
+sys32_old_select
+sys_symlink
+sys_lstat
+sys_readlink
+sys_uselib
+sys_swapon
+sys_reboot
+compat_sys_old_readdir
+sys32_mmap
+sys_munmap
+sys_truncate
+sys_ftruncate
+sys_fchmod
+sys_fchown16
+sys_getpriority
+sys_setpriority
+quiet_ni_syscall
+compat_sys_statfs
+compat_sys_fstatfs
+sys_ioperm
+compat_sys_socketcall
+sys_syslog
+compat_sys_setitimer
+compat_sys_getitimer
+compat_sys_newstat
+compat_sys_newlstat
+compat_sys_newfstat
+sys32_uname
+stub32_iopl
+sys_vhangup
+quiet_ni_syscall
+sys32_vm86_warning
+compat_sys_wait4
+sys_swapoff
+compat_sys_sysinfo
+sys32_ipc
+sys_fsync
+stub32_sigreturn
+stub32_clone
+sys_setdomainname
+sys_uname
+sys_modify_ldt
+compat_sys_adjtimex
+sys32_mprotect
+compat_sys_sigprocmask
+quiet_ni_syscall
+sys_init_module
+sys_delete_module
+quiet_ni_syscall
+sys32_quotactl
+sys_getpgid
+sys_fchdir
+quiet_ni_syscall
+sys_sysfs
+sys_personality
+quiet_ni_syscall
+sys_setfsuid16
+sys_setfsgid16
+sys_llseek
+compat_sys_getdents
+compat_sys_select
+sys_flock
+sys_msync
+compat_sys_readv
+compat_sys_writev
+sys_getsid
+sys_fdatasync
+compat_sys_sysctl
+sys_mlock
+sys_munlock
+sys_mlockall
+sys_munlockall
+sys_sched_setparam
+sys_sched_getparam
+sys_sched_setscheduler
+sys_sched_getscheduler
+sys_sched_yield
+sys_sched_get_priority_max
+sys_sched_get_priority_min
+sys32_sched_rr_get_interval
+compat_sys_nanosleep
+sys_mremap
+sys_setresuid16
+sys_getresuid16
+sys32_vm86_warning
+quiet_ni_syscall
+sys_poll
+compat_sys_nfsservctl
+sys_setresgid16
+sys_getresgid16
+sys_prctl
+stub32_rt_sigreturn
+sys32_rt_sigaction
+sys32_rt_sigprocmask
+sys32_rt_sigpending
+compat_sys_rt_sigtimedwait
+sys32_rt_sigqueueinfo
+sys_rt_sigsuspend
+sys32_pread
+sys32_pwrite
+sys_chown16
+sys_getcwd
+sys_capget
+sys_capset
+stub32_sigaltstack
+sys32_sendfile
+quiet_ni_syscall
+quiet_ni_syscall
+stub32_vfork
+compat_sys_getrlimit
+sys32_mmap2
+sys32_truncate64
+sys32_ftruncate64
+sys32_stat64
+sys32_lstat64
+sys32_fstat64
+sys_lchown
+sys_getuid
+sys_getgid
+sys_geteuid
+sys_getegid
+sys_setreuid
+sys_setregid
+sys_getgroups
+sys_setgroups
+sys_fchown
+sys_setresuid
+sys_getresuid
+sys_setresgid
+sys_getresgid
+sys_chown
+sys_setuid
+sys_setgid
+sys_setfsuid
+sys_setfsgid
+sys_pivot_root
+sys_mincore
+sys_madvise
+compat_sys_getdents64
+compat_sys_fcntl64	
+quiet_ni_syscall
+quiet_ni_syscall
+sys_gettid	
+sys32_readahead
+sys_setxattr
+sys_lsetxattr
+sys_fsetxattr
+sys_getxattr
+sys_lgetxattr
+sys_fgetxattr
+sys_listxattr
+sys_llistxattr
+sys_flistxattr
+sys_removexattr
+sys_lremovexattr
+sys_fremovexattr
+sys_tkill
+sys_sendfile64 
+compat_sys_futex
+compat_sys_sched_setaffinity
+compat_sys_sched_getaffinity
+sys_set_thread_area
+sys_get_thread_area
+compat_sys_io_setup
+sys_io_destroy
+compat_sys_io_getevents
+compat_sys_io_submit
+sys_io_cancel
+sys32_fadvise64
+quiet_ni_syscall
+sys_exit_group
+sys32_lookup_dcookie
+sys_epoll_create
+sys_epoll_ctl
+sys_epoll_wait
+sys_remap_file_pages
+sys_set_tid_address
+compat_sys_timer_create
+compat_sys_timer_settime
+compat_sys_timer_gettime
+sys_timer_getoverrun
+sys_timer_delete
+compat_sys_clock_settime
+compat_sys_clock_gettime
+compat_sys_clock_getres
+compat_sys_clock_nanosleep
+compat_sys_statfs64
+compat_sys_fstatfs64
+sys_tgkill
+compat_sys_utimes
+sys32_fadvise64_64
+quiet_ni_syscall
+sys_mbind
+compat_sys_get_mempolicy
+sys_set_mempolicy
+compat_sys_mq_open
+sys_mq_unlink
+compat_sys_mq_timedsend
+compat_sys_mq_timedreceive
+compat_sys_mq_notify
+compat_sys_mq_getsetattr
+compat_sys_kexec_load
+compat_sys_waitid
+quiet_ni_syscall
+sys_add_key
+sys_request_key
+sys_keyctl
+sys_ioprio_set
+sys_ioprio_get
+sys_inotify_init
+sys_inotify_add_watch
+sys_inotify_rm_watch
+sys_migrate_pages
+compat_sys_openat
+sys_mkdirat
+sys_mknodat
+sys_fchownat
+compat_sys_futimesat
+sys32_fstatat
+sys_unlinkat
+sys_renameat
+sys_linkat
+sys_symlinkat
+sys_readlinkat
+sys_fchmodat
+sys_faccessat
+compat_sys_pselect6
+compat_sys_ppoll
+sys_unshare
+compat_sys_set_robust_list
+compat_sys_get_robust_list
+sys_splice
+sys32_sync_file_range
+sys_tee
+compat_sys_vmsplice
+compat_sys_move_pages
+sys_getcpu
+sys_epoll_pwait
+compat_sys_utimensat			CAP
+compat_sys_signalfd
+sys_timerfd_create
+sys_eventfd
+sys32_fallocate
+compat_sys_timerfd_settime
+compat_sys_timerfd_gettime
+compat_sys_signalfd4
+sys_eventfd2
+sys_epoll_create1
+sys_dup3
+sys_pipe2
+sys_inotify_init1
+compat_sys_preadv
+compat_sys_pwritev
+compat_sys_rt_tgsigqueueinfo
+sys_perf_event_open
+compat_sys_recvmmsg
+
+Syscall_0:
+sys_restart_syscall
+
+=== END OF SYSCALL TABLE ===
+*) The line number corresponds to syscall number
+
+syscall table is in arch/x86/ia32/ia32entry.S
diff -ruNp linux-2.6.34.5/arch/x86/SYSCALLS.x86_64 linux-2.6.34.5-cher1/arch/x86/SYSCALLS.x86_64
--- linux-2.6.34.5/arch/x86/SYSCALLS.x86_64	1970-01-01 03:00:00.000000000 +0300
+++ linux-2.6.34.5-cher1/arch/x86/SYSCALLS.x86_64	2010-08-26 14:45:12.246567969 +0400
@@ -0,0 +1,307 @@
+sys_write
+sys_open
+sys_close
+sys_newstat
+sys_newfstat
+sys_newlstat
+sys_poll
+sys_lseek
+sys_mmap
+sys_mprotect
+sys_munmap
+sys_brk
+sys_rt_sigaction
+sys_rt_sigprocmask
+stub_rt_sigreturn
+sys_ioctl
+sys_pread64
+sys_pwrite64
+sys_readv
+sys_writev
+sys_access
+sys_pipe
+sys_select
+sys_sched_yield
+sys_mremap
+sys_msync
+sys_mincore
+sys_madvise
+sys_shmget
+sys_shmat
+sys_shmctl
+sys_dup
+sys_dup2
+sys_pause
+sys_nanosleep
+sys_getitimer
+sys_alarm
+sys_setitimer
+sys_getpid
+sys_sendfile64
+sys_socket
+sys_connect
+sys_accept
+sys_sendto
+sys_recvfrom
+sys_sendmsg
+sys_recvmsg
+sys_shutdown
+sys_bind
+sys_listen
+sys_getsockname
+sys_getpeername
+sys_socketpair
+sys_setsockopt
+sys_getsockopt
+stub_clone
+stub_fork
+stub_vfork
+stub_execve
+sys_exit
+sys_wait4
+sys_kill
+sys_uname
+sys_semget
+sys_semop
+sys_semctl
+sys_shmdt
+sys_msgget
+sys_msgsnd
+sys_msgrcv
+sys_msgctl
+sys_fcntl
+sys_flock
+sys_fsync
+sys_fdatasync
+sys_truncate
+sys_ftruncate
+sys_getdents
+sys_getcwd
+sys_chdir
+sys_fchdir
+sys_rename
+sys_mkdir
+sys_rmdir
+sys_creat
+sys_link
+sys_unlink
+sys_symlink
+sys_readlink
+sys_chmod
+sys_fchmod
+sys_chown
+sys_fchown
+sys_lchown
+sys_umask
+sys_gettimeofday
+sys_getrlimit
+sys_getrusage
+sys_sysinfo
+sys_times
+sys_ptrace
+sys_getuid
+sys_syslog
+sys_getgid
+sys_setuid
+sys_setgid
+sys_geteuid
+sys_getegid
+sys_setpgid
+sys_getppid
+sys_getpgrp
+sys_setsid
+sys_setreuid
+sys_setregid
+sys_getgroups
+sys_setgroups
+sys_setresuid
+sys_getresuid
+sys_setresgid
+sys_getresgid
+sys_getpgid
+sys_setfsuid
+sys_setfsgid
+sys_getsid
+sys_capget
+sys_capset
+sys_rt_sigpending
+sys_rt_sigtimedwait
+sys_rt_sigqueueinfo
+sys_rt_sigsuspend
+stub_sigaltstack
+sys_utime
+sys_mknod
+sys_ni_syscall
+sys_personality
+sys_ustat
+sys_statfs
+sys_fstatfs
+sys_sysfs
+sys_getpriority
+sys_setpriority
+sys_sched_setparam
+sys_sched_getparam
+sys_sched_setscheduler
+sys_sched_getscheduler
+sys_sched_get_priority_max
+sys_sched_get_priority_min
+sys_sched_rr_get_interval
+sys_mlock
+sys_munlock
+sys_mlockall
+sys_munlockall
+sys_vhangup
+sys_modify_ldt
+sys_pivot_root
+sys_sysctl
+sys_prctl
+sys_arch_prctl
+sys_adjtimex
+sys_setrlimit
+sys_chroot
+sys_sync
+sys_acct
+sys_settimeofday
+sys_mount
+sys_umount
+sys_swapon
+sys_swapoff
+sys_reboot
+sys_sethostname
+sys_setdomainname
+stub_iopl
+sys_ioperm
+sys_ni_syscall
+sys_init_module
+sys_delete_module
+sys_ni_syscall
+sys_ni_syscall
+sys_quotactl
+sys_nfsservctl
+sys_ni_syscall
+sys_ni_syscall
+sys_ni_syscall
+sys_ni_syscall
+sys_ni_syscall
+sys_gettid
+sys_readahead
+sys_setxattr
+sys_lsetxattr
+sys_fsetxattr
+sys_getxattr
+sys_lgetxattr
+sys_fgetxattr
+sys_listxattr
+sys_llistxattr
+sys_flistxattr
+sys_removexattr
+sys_lremovexattr
+sys_fremovexattr
+sys_tkill
+sys_time
+sys_futex
+sys_sched_setaffinity
+sys_sched_getaffinity
+sys_ni_syscall
+sys_io_setup
+sys_io_destroy
+sys_io_getevents
+sys_io_submit
+sys_io_cancel
+sys_ni_syscall
+sys_lookup_dcookie
+sys_epoll_create
+sys_ni_syscall
+sys_ni_syscall
+sys_remap_file_pages
+sys_getdents64
+sys_set_tid_address
+sys_restart_syscall
+sys_semtimedop
+sys_fadvise64
+sys_timer_create
+sys_timer_settime
+sys_timer_gettime
+sys_timer_getoverrun
+sys_timer_delete
+sys_clock_settime
+sys_clock_gettime
+sys_clock_getres
+sys_clock_nanosleep
+sys_exit_group
+sys_epoll_wait
+sys_epoll_ctl
+sys_tgkill
+sys_utimes
+sys_ni_syscall
+sys_mbind
+sys_set_mempolicy
+sys_get_mempolicy
+sys_mq_open
+sys_mq_unlink
+sys_mq_timedsend
+sys_mq_timedreceive
+sys_mq_notify
+sys_mq_getsetattr
+sys_kexec_load
+sys_waitid
+sys_add_key
+sys_request_key
+sys_keyctl
+sys_ioprio_set
+sys_ioprio_get
+sys_inotify_init
+sys_inotify_add_watch
+sys_inotify_rm_watch
+sys_migrate_pages
+sys_openat
+sys_mkdirat
+sys_mknodat
+sys_fchownat
+sys_futimesat
+sys_newfstatat
+sys_unlinkat
+sys_renameat
+sys_linkat
+sys_symlinkat
+sys_readlinkat
+sys_fchmodat
+sys_faccessat
+sys_pselect6
+sys_ppoll
+sys_unshare
+sys_set_robust_list
+sys_get_robust_list
+sys_splice
+sys_tee
+sys_sync_file_range
+sys_vmsplice
+sys_move_pages
+sys_utimensat
+sys_epoll_pwait
+sys_signalfd
+sys_timerfd_create
+sys_eventfd
+sys_fallocate
+sys_timerfd_settime
+sys_timerfd_gettime
+sys_accept4
+sys_signalfd4
+sys_eventfd2
+sys_epoll_create1
+sys_dup3
+sys_pipe2
+sys_inotify_init1
+sys_preadv
+sys_pwritev
+sys_rt_tgsigqueueinfo
+sys_perf_event_open
+sys_recvmmsg
+
+Syscall_0:
+sys_read
+
+=== END OF SYSCALL TABLE ===
+*) The line number corresponds to syscall number
+
+syscall table is in include/asm-x86/unistd_64.h
diff -ruNp linux-2.6.34.5/fs/aio.c linux-2.6.34.5-cher1/fs/aio.c
--- linux-2.6.34.5/fs/aio.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/aio.c	2010-08-26 14:45:12.247567342 +0400
@@ -1248,6 +1248,9 @@ SYSCALL_DEFINE2(io_setup, unsigned, nr_e
 	unsigned long ctx;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	ret = get_user(ctx, ctxp);
 	if (unlikely(ret))
 		goto out;
@@ -1282,7 +1285,13 @@ out:
  */
 SYSCALL_DEFINE1(io_destroy, aio_context_t, ctx)
 {
-	struct kioctx *ioctx = lookup_ioctx(ctx);
+	struct kioctx *ioctx;
+
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
+	ioctx = lookup_ioctx(ctx);
+
 	if (likely(NULL != ioctx)) {
 		io_destroy(ioctx);
 		return 0;
@@ -1711,6 +1720,9 @@ long do_io_submit(aio_context_t ctx_id, 
 SYSCALL_DEFINE3(io_submit, aio_context_t, ctx_id, long, nr,
 		struct iocb __user * __user *, iocbpp)
 {
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	return do_io_submit(ctx_id, nr, iocbpp, 0);
 }
 
@@ -1752,6 +1764,9 @@ SYSCALL_DEFINE3(io_cancel, aio_context_t
 	u32 key;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	ret = get_user(key, &iocb->aio_key);
 	if (unlikely(ret))
 		return -EFAULT;
@@ -1811,9 +1826,14 @@ SYSCALL_DEFINE5(io_getevents, aio_contex
 		struct io_event __user *, events,
 		struct timespec __user *, timeout)
 {
-	struct kioctx *ioctx = lookup_ioctx(ctx_id);
+	struct kioctx *ioctx;
 	long ret = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
+	ioctx = lookup_ioctx(ctx_id);
+
 	if (likely(ioctx)) {
 		if (likely(min_nr <= nr && min_nr >= 0 && nr >= 0))
 			ret = read_events(ioctx, min_nr, nr, events, timeout);
diff -ruNp linux-2.6.34.5/fs/binfmt_aout.c linux-2.6.34.5-cher1/fs/binfmt_aout.c
--- linux-2.6.34.5/fs/binfmt_aout.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/binfmt_aout.c	2010-08-26 14:45:12.256584401 +0400
@@ -238,8 +238,12 @@ static int load_aout_binary(struct linux
 	rlim = rlimit(RLIMIT_DATA);
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
-	if (ex.a_data + ex.a_bss > rlim)
+	if (ex.a_data + ex.a_bss > rlim) {
+		if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+			current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+		}
 		return -ENOMEM;
+	}
 
 	/* Flush all traces of the currently running executable */
 	retval = flush_old_exec(bprm);
diff -ruNp linux-2.6.34.5/fs/binfmt_flat.c linux-2.6.34.5-cher1/fs/binfmt_flat.c
--- linux-2.6.34.5/fs/binfmt_flat.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/binfmt_flat.c	2010-08-26 14:45:12.257563520 +0400
@@ -505,6 +505,9 @@ static int load_flat_file(struct linux_b
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
 	if (data_len + bss_len > rlim) {
+		if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+			current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+		}
 		ret = -ENOMEM;
 		goto err;
 	}
diff -ruNp linux-2.6.34.5/fs/buffer.c linux-2.6.34.5-cher1/fs/buffer.c
--- linux-2.6.34.5/fs/buffer.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/buffer.c	2010-08-26 14:45:12.260572394 +0400
@@ -3214,6 +3214,11 @@ SYSCALL_DEFINE2(bdflush, int, func, long
 {
 	static int msg_count;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
diff -ruNp linux-2.6.34.5/fs/compat.c linux-2.6.34.5-cher1/fs/compat.c
--- linux-2.6.34.5/fs/compat.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/compat.c	2010-08-26 14:45:12.269562073 +0400
@@ -80,6 +80,11 @@ asmlinkage long compat_sys_utime(char __
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (t) {
 		if (get_user(tv[0].tv_sec, &t->actime) ||
 		    get_user(tv[1].tv_sec, &t->modtime))
@@ -94,6 +99,11 @@ asmlinkage long compat_sys_utimensat(uns
 {
 	struct timespec tv[2];
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if  (t) {
 		if (get_compat_timespec(&tv[0], &t[0]) ||
 		    get_compat_timespec(&tv[1], &t[1]))
@@ -109,6 +119,11 @@ asmlinkage long compat_sys_futimesat(uns
 {
 	struct timespec tv[2];
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	if (t) {
 		if (get_user(tv[0].tv_sec, &t[0].tv_sec) ||
 		    get_user(tv[0].tv_nsec, &t[0].tv_usec) ||
@@ -174,6 +189,9 @@ asmlinkage long compat_sys_newstat(char 
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	error = vfs_stat(filename, &stat);
 	if (error)
 		return error;
@@ -186,6 +204,9 @@ asmlinkage long compat_sys_newlstat(char
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	error = vfs_lstat(filename, &stat);
 	if (error)
 		return error;
@@ -199,6 +220,11 @@ asmlinkage long compat_sys_newfstatat(un
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	error = vfs_fstatat(dfd, filename, &stat, flag);
 	if (error)
 		return error;
@@ -210,7 +236,14 @@ asmlinkage long compat_sys_newfstat(unsi
 		struct compat_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
+	error = vfs_fstat(fd, &stat);
 
 	if (!error)
 		error = cp_compat_stat(&stat, statbuf);
@@ -263,6 +296,11 @@ asmlinkage long compat_sys_statfs(const 
 	struct path path;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	error = user_path(pathname, &path);
 	if (!error) {
 		struct kstatfs tmp;
@@ -280,6 +318,11 @@ asmlinkage long compat_sys_fstatfs(unsig
 	struct kstatfs tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -328,6 +371,11 @@ asmlinkage long compat_sys_statfs64(cons
 	struct path path;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -348,6 +396,11 @@ asmlinkage long compat_sys_fstatfs64(uns
 	struct kstatfs tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -375,6 +428,11 @@ asmlinkage long compat_sys_ustat(unsigne
 	struct kstatfs sbuf;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sb = user_get_super(new_decode_dev(dev));
 	if (!sb)
 		return -EINVAL;
@@ -450,6 +508,9 @@ asmlinkage long compat_sys_fcntl64(unsig
 	struct flock f;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	switch (cmd) {
 	case F_GETLK:
 	case F_SETLK:
@@ -515,6 +576,9 @@ asmlinkage long compat_sys_fcntl64(unsig
 asmlinkage long compat_sys_fcntl(unsigned int fd, unsigned int cmd,
 		unsigned long arg)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if ((cmd == F_GETLK64) || (cmd == F_SETLK64) || (cmd == F_SETLKW64))
 		return -EINVAL;
 	return compat_sys_fcntl64(fd, cmd, arg);
@@ -525,8 +589,14 @@ compat_sys_io_setup(unsigned nr_reqs, u3
 {
 	long ret;
 	aio_context_t ctx64;
+	mm_segment_t oldfs;
+
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
 
-	mm_segment_t oldfs = get_fs();
+        oldfs = get_fs();
 	if (unlikely(get_user(ctx64, ctx32p)))
 		return -EFAULT;
 
@@ -551,6 +621,11 @@ compat_sys_io_getevents(aio_context_t ct
 	struct timespec t;
 	struct timespec __user *ut = NULL;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	ret = -EFAULT;
 	if (unlikely(!access_ok(VERIFY_WRITE, events, 
 				nr * sizeof(struct io_event))))
@@ -664,6 +739,11 @@ compat_sys_io_submit(aio_context_t ctx_i
 	struct iocb __user * __user *iocb64; 
 	long ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (unlikely(nr < 0))
 		return -EINVAL;
 
@@ -846,6 +926,11 @@ asmlinkage long compat_sys_mount(char __
 	char *dir_page;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	retval = copy_mount_string(type, &kernel_type);
 	if (retval < 0)
 		goto out;
@@ -944,6 +1029,11 @@ asmlinkage long compat_sys_old_readdir(u
 	struct file *file;
 	struct compat_readdir_callback buf;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -1025,6 +1115,11 @@ asmlinkage long compat_sys_getdents(unsi
 	struct compat_getdents_callback buf;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -1113,6 +1208,11 @@ asmlinkage long compat_sys_getdents64(un
 	struct compat_getdents_callback64 buf;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -1232,6 +1332,11 @@ compat_sys_readv(unsigned long fd, const
 	int fput_needed;
 	ssize_t ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	file = fget_light(fd, &fput_needed);
 	if (!file)
 		return -EBADF;
@@ -1249,6 +1354,11 @@ compat_sys_preadv(unsigned long fd, cons
 	int fput_needed;
 	ssize_t ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	if (pos < 0)
 		return -EINVAL;
 	file = fget_light(fd, &fput_needed);
@@ -1289,6 +1399,11 @@ compat_sys_writev(unsigned long fd, cons
 	int fput_needed;
 	ssize_t ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	file = fget_light(fd, &fput_needed);
 	if (!file)
 		return -EBADF;
@@ -1306,6 +1421,11 @@ compat_sys_pwritev(unsigned long fd, con
 	int fput_needed;
 	ssize_t ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	if (pos < 0)
 		return -EINVAL;
 	file = fget_light(fd, &fput_needed);
@@ -1322,6 +1442,12 @@ compat_sys_vmsplice(int fd, const struct
 {
 	unsigned i;
 	struct iovec __user *iov;
+
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	if (nr_segs > UIO_MAXIOV)
 		return -EINVAL;
 	iov = compat_alloc_user_space(nr_segs * sizeof(struct iovec));
@@ -1353,6 +1479,11 @@ compat_sys_open(const char __user *filen
 asmlinkage long
 compat_sys_openat(unsigned int dfd, const char __user *filename, int flags, int mode)
 {
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	return do_sys_open(dfd, filename, flags, mode);
 }
 
@@ -2146,6 +2277,11 @@ asmlinkage long compat_sys_nfsservctl(in
 	mm_segment_t oldfs;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	karg = kmalloc(sizeof(*karg), GFP_USER);
 	kres = kmalloc(sizeof(*kres), GFP_USER);
 	if(!karg || !kres) {
@@ -2272,6 +2408,11 @@ asmlinkage long compat_sys_signalfd4(int
 	sigset_t tmp;
 	sigset_t __user *ksigmask;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	if (sigsetsize != sizeof(compat_sigset_t))
 		return -EINVAL;
 	if (copy_from_user(&ss32, sigmask, sizeof(ss32)))
@@ -2302,6 +2443,11 @@ asmlinkage long compat_sys_timerfd_setti
 	struct itimerspec t;
 	struct itimerspec __user *ut;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	if (get_compat_itimerspec(&t, utmr))
 		return -EFAULT;
 	ut = compat_alloc_user_space(2 * sizeof(struct itimerspec));
@@ -2322,6 +2468,11 @@ asmlinkage long compat_sys_timerfd_getti
 	struct itimerspec t;
 	struct itimerspec __user *ut;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	ut = compat_alloc_user_space(sizeof(struct itimerspec));
 	error = sys_timerfd_gettime(ufd, ut);
 	if (!error)
diff -ruNp linux-2.6.34.5/fs/compat_ioctl.c linux-2.6.34.5-cher1/fs/compat_ioctl.c
--- linux-2.6.34.5/fs/compat_ioctl.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/compat_ioctl.c	2010-08-26 14:45:12.276562085 +0400
@@ -1681,6 +1681,9 @@ asmlinkage long compat_sys_ioctl(unsigne
 	int error = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (!filp)
 		goto out;
diff -ruNp linux-2.6.34.5/fs/dcache.c linux-2.6.34.5-cher1/fs/dcache.c
--- linux-2.6.34.5/fs/dcache.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/dcache.c	2010-08-26 14:45:12.277567604 +0400
@@ -2106,7 +2106,14 @@ SYSCALL_DEFINE2(getcwd, char __user *, b
 {
 	int error;
 	struct path pwd, root;
-	char *page = (char *) __get_free_page(GFP_USER);
+	char *page;
+
+        if (SBOX_IS_RESTRICTED()) {
+		copy_to_user(buf, "/SANDBOX", 9);
+                return 9;
+	}
+
+        page = (char *) __get_free_page(GFP_USER);
 
 	if (!page)
 		return -ENOMEM;
diff -ruNp linux-2.6.34.5/fs/dcookies.c linux-2.6.34.5-cher1/fs/dcookies.c
--- linux-2.6.34.5/fs/dcookies.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/dcookies.c	2010-08-26 14:45:12.277567604 +0400
@@ -25,6 +25,7 @@
 #include <linux/dcookies.h>
 #include <linux/mutex.h>
 #include <linux/path.h>
+#include <linux/sched.h>
 #include <asm/uaccess.h>
 
 /* The dcookies are allocated from a kmem_cache and
@@ -154,6 +155,9 @@ SYSCALL_DEFINE(lookup_dcookie)(u64 cooki
 	size_t pathlen;
 	struct dcookie_struct * dcs;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	/* we could leak path information to users
 	 * without dir read permission without this
 	 */
diff -ruNp linux-2.6.34.5/fs/eventfd.c linux-2.6.34.5-cher1/fs/eventfd.c
--- linux-2.6.34.5/fs/eventfd.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/eventfd.c	2010-08-26 14:45:12.278567325 +0400
@@ -411,6 +411,9 @@ SYSCALL_DEFINE2(eventfd2, unsigned int, 
 	int fd, error;
 	struct file *file;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	error = get_unused_fd_flags(flags & EFD_SHARED_FCNTL_FLAGS);
 	if (error < 0)
 		return error;
diff -ruNp linux-2.6.34.5/fs/eventpoll.c linux-2.6.34.5-cher1/fs/eventpoll.c
--- linux-2.6.34.5/fs/eventpoll.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/eventpoll.c	2010-08-26 14:45:12.278567325 +0400
@@ -1190,6 +1190,9 @@ SYSCALL_DEFINE1(epoll_create1, int, flag
 	int error;
 	struct eventpoll *ep = NULL;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	/* Check the EPOLL_* constant for consistency.  */
 	BUILD_BUG_ON(EPOLL_CLOEXEC != O_CLOEXEC);
 
@@ -1215,6 +1218,9 @@ SYSCALL_DEFINE1(epoll_create1, int, flag
 
 SYSCALL_DEFINE1(epoll_create, int, size)
 {
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	if (size <= 0)
 		return -EINVAL;
 
@@ -1235,6 +1241,9 @@ SYSCALL_DEFINE4(epoll_ctl, int, epfd, in
 	struct epitem *epi;
 	struct epoll_event epds;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	error = -EFAULT;
 	if (ep_op_has_event(op) &&
 	    copy_from_user(&epds, event, sizeof(struct epoll_event)))
@@ -1325,6 +1334,9 @@ SYSCALL_DEFINE4(epoll_wait, int, epfd, s
 	struct file *file;
 	struct eventpoll *ep;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	/* The maximum number of event must be greater than zero */
 	if (maxevents <= 0 || maxevents > EP_MAX_EVENTS)
 		return -EINVAL;
@@ -1378,6 +1390,9 @@ SYSCALL_DEFINE6(epoll_pwait, int, epfd, 
 	int error;
 	sigset_t ksigmask, sigsaved;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	/*
 	 * If the caller wants a certain signal mask to be set during the wait,
 	 * we apply it here.
diff -ruNp linux-2.6.34.5/fs/exec.c linux-2.6.34.5-cher1/fs/exec.c
--- linux-2.6.34.5/fs/exec.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/exec.c	2010-08-26 14:45:12.279562788 +0400
@@ -107,8 +107,14 @@ static inline void put_binfmt(struct lin
 SYSCALL_DEFINE1(uselib, const char __user *, library)
 {
 	struct file *file;
-	char *tmp = getname(library);
-	int error = PTR_ERR(tmp);
+	char *tmp = NULL;
+	int error = -EPERM;
+
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
+        tmp = getname(library);
+        error = PTR_ERR(tmp);
 
 	if (IS_ERR(tmp))
 		goto out;
diff -ruNp linux-2.6.34.5/fs/fcntl.c linux-2.6.34.5-cher1/fs/fcntl.c
--- linux-2.6.34.5/fs/fcntl.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/fcntl.c	2010-08-26 14:45:12.280567539 +0400
@@ -56,6 +56,9 @@ SYSCALL_DEFINE3(dup3, unsigned int, oldf
 	struct files_struct * files = current->files;
 	struct fdtable *fdt;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if ((flags & ~O_CLOEXEC) != 0)
 		return -EINVAL;
 
@@ -114,6 +117,9 @@ out_unlock:
 
 SYSCALL_DEFINE2(dup2, unsigned int, oldfd, unsigned int, newfd)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (unlikely(newfd == oldfd)) { /* corner case */
 		struct files_struct *files = current->files;
 		int retval = oldfd;
@@ -130,8 +136,12 @@ SYSCALL_DEFINE2(dup2, unsigned int, oldf
 SYSCALL_DEFINE1(dup, unsigned int, fildes)
 {
 	int ret = -EBADF;
-	struct file *file = fget(fildes);
+	struct file *file = NULL;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
+	file = fget(fildes);
 	if (file) {
 		ret = get_unused_fd();
 		if (ret >= 0)
@@ -423,6 +433,9 @@ SYSCALL_DEFINE3(fcntl, unsigned int, fd,
 	struct file *filp;
 	long err = -EBADF;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	filp = fget(fd);
 	if (!filp)
 		goto out;
@@ -447,6 +460,9 @@ SYSCALL_DEFINE3(fcntl64, unsigned int, f
 	struct file * filp;
 	long err;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	err = -EBADF;
 	filp = fget(fd);
 	if (!filp)
diff -ruNp linux-2.6.34.5/fs/filesystems.c linux-2.6.34.5-cher1/fs/filesystems.c
--- linux-2.6.34.5/fs/filesystems.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/filesystems.c	2010-08-26 14:45:12.280567539 +0400
@@ -14,6 +14,7 @@
 #include <linux/init.h>
 #include <linux/module.h>
 #include <linux/slab.h>
+#include <linux/sched.h>
 #include <asm/uaccess.h>
 
 /*
@@ -183,6 +184,11 @@ SYSCALL_DEFINE3(sysfs, int, option, unsi
 {
 	int retval = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	switch (option) {
 		case 1:
 			retval = fs_index((const char __user *) arg1);
diff -ruNp linux-2.6.34.5/fs/ioctl.c linux-2.6.34.5-cher1/fs/ioctl.c
--- linux-2.6.34.5/fs/ioctl.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/ioctl.c	2010-08-26 14:45:12.281562303 +0400
@@ -627,6 +627,9 @@ SYSCALL_DEFINE3(ioctl, unsigned int, fd,
 	int error = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (!filp)
 		goto out;
diff -ruNp linux-2.6.34.5/fs/ioprio.c linux-2.6.34.5-cher1/fs/ioprio.c
--- linux-2.6.34.5/fs/ioprio.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/ioprio.c	2010-08-26 14:45:12.281562303 +0400
@@ -82,6 +82,11 @@ SYSCALL_DEFINE3(ioprio_set, int, which, 
 	struct pid *pgrp;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	switch (class) {
 		case IOPRIO_CLASS_RT:
 			if (!capable(CAP_SYS_ADMIN))
@@ -197,6 +202,11 @@ SYSCALL_DEFINE2(ioprio_get, int, which, 
 	int ret = -ESRCH;
 	int tmpio;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	read_lock(&tasklist_lock);
 	switch (which) {
 		case IOPRIO_WHO_PROCESS:
diff -ruNp linux-2.6.34.5/fs/locks.c linux-2.6.34.5-cher1/fs/locks.c
--- linux-2.6.34.5/fs/locks.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/locks.c	2010-08-26 14:45:12.282557206 +0400
@@ -1573,6 +1573,11 @@ SYSCALL_DEFINE2(flock, unsigned int, fd,
 	int can_sleep, unlock;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = -EBADF;
 	filp = fget(fd);
 	if (!filp)
